; $Id: isoviz.pro,v 1.1 2010/06/01 10:52:09 kg Exp $
PRO BBoxFade, oBBox, oModel
;+
;  Fade the intensity of the Bounding Box according to projected z-values
;-
    oBBox->GetProperty, DATA=vert
    oModel->GetProperty, TRANSFORM=t
    nv = (size(vert))[2]
    z = fltarr(nv)
    for i=0,nv-1 do z(i)=([vert[*,i],1.]#t)[2]
    min = 120
    z = min+bytscl(z,top=255-min)
    oBBox->SetProperty, VERT_COLORS=z, /SHADING
END

PRO viz2_event, sEvent
;+
;  Handle events for VOLVIZ and ISOVIZ
;-
    WIDGET_CONTROL, sEvent.top, GET_UVALUE=sState    ; Get state

    tag = TAG_NAMES(sEvent, /STRUCTURE_NAME)
    CASE tag OF
    'WIDGET_KILL_REQUEST': BEGIN                     ; Kill request
        IF n_elements(sState) eq 0 THEN return
        viz_cleanup, sState
        OBJ_DESTROY, sState.oHolder
        WIDGET_CONTROL, sEvent.top, /DESTROY
        RETURN
    END
    'WIDGET_BASE': BEGIN                             ; Resize request
        xsz = sEvent.x-3
        ysz = sEvent.y

        sState.oMainWindow->GetProperty, DIM=dim1
        sState.oPlotWindow->GetProperty, DIM=dim2
        g = WIDGET_INFO(sState.wButtons,/geometry)

        sState.oMainWindow->SetProperty, DIM=[xsz-dim2[0]-g.xsize,ysz]
        sState.oPlotWindow->SetProperty, DIM=[dim2[0],ysz]

        sState.oMainView->Remove, sState.oLights
        set_view, sState.oMainView, sState.oMainWindow, /ISOTR
        sState.oMainView->Add, sState.oLights
        sState.oMainWindow->Draw, sState.oMainView
        sState.oPlotWindow->Draw, sState.oPlotView

        sState.xsize = xsz
        WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
        RETURN
    END
    ELSE:
    ENDCASE

    WIDGET_CONTROL, sEvent.id, GET_UVALUE=uval
    ;print,'event :', tag, ' uvalue: ',uval, ' type: ', sEvent.type

    CASE uval OF
        'HIST': BEGIN                                    ; IsoViz
           CASE sEvent.type OF
           0: sState.active = 1
           1: sState.active = 0
           ELSE:
           ENDCASE
           IF sState.active EQ 1 THEN BEGIN
             viz_click, sState, sEvent
           ENDIF
           WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
        END

        'OPAC': BEGIN                                    ; VolViz
           CASE sEvent.type OF
             0: BEGIN                                    ; Mouse press
                sState.active = 1
                sState.xprv = long(255.*(sEvent.x > 0)/sState.xsize) < 255
                sState.yprv = long(255.*(sEvent.y > 0)/sState.ysize) < 255
                WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
             END
             1: BEGIN                                    ; Mouse release
                sState.active=0
                sState.oMainWindow->draw, sState.oMainView
               WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
             END
             2: BEGIN                                    ; Mouse motion
                if (sState.active eq 0) then return
                x = long(255.*(sEvent.x > 0)/sState.xsize) < 255
                y = long(255.*(sEvent.y > 0)/sState.ysize) < 255
                x0 = sState.xprv
                y0 = sState.yprv
                i0 = (x0 < x)
                i1 = (x > x0)
                FOR i = i0, i1 DO BEGIN
                    sState.opac[i]=y0+((y-y0)*(i-i0))/(i1-i0+1e-6)
                ENDFOR
                sState.xprv = x
                sState.yprv = y

                sState.oPlot->SetProperty, DATAY=sState.opac
                sState.oVolume->SetProperty, OPACITY_TABLE0=sState.opac
                sState.oPlotWindow->draw, sState.oPlotView

                WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
             END
             ELSE: BEGIN                                 ; Ignore others
             END
           ENDCASE
        END
        'MAIN': BEGIN

           CASE sEvent.type OF
           0: BEGIN                                    ; Mouse press
                sState.active = 1
                if sState.type eq 'isoviz' then begin
                  loc = [sEvent.x, sEvent.y]
                  if sState.oMainWindow->PickData(sState.oMainView,sState.oPolygon,loc,xyz) then begin
                    ;print,'PickData: xyz=',xyz
                    sState.center = sState.center + (xyz-sState.sz[1:3]/2)
                    sState.zoom = (sState.zoomf*sState.zoom) < 1.0
                    print,'      new center:',sState.center
                    print,'zoomfactor, zoom:',sState.zoomf,sState.zoom
                    viz_click, sState, {x:0, y:-1, top:sEvent.top}
                  endif
                  if !d.name eq 'MAC' then $
                    sState.oModel->remove, sState.oPolygon
                endif
                if sState.type eq 'volviz' then $
                  sState.oModel->remove, sState.oVolume
                sState.oMainWindow->draw, sState.oMainView
                WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
           END
           1: BEGIN                                    ; Mouse release
                sState.active = 0
                if sState.type eq 'isoviz' $
                and !d.name eq 'MAC' then $
                  sState.oModel->add, sState.oPolygon
                if sState.type eq 'volviz' then $
                  sState.oModel->add, sState.oVolume
                sState.oMainWindow->draw, sState.oMainView
                WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
           END
           4: BEGIN                                    ; Expose
               BBoxFade, sState.oBBox, sState.oModel
               sState.oMainWindow->Draw, sState.oMainView
               sState.oPlotWindow->Draw, sState.oPlotView
               WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
               RETURN
           END
           ELSE:
           END

           bHaveTransform = sState.oTrack->Update( sEvent, TRANSFORM=qmat )
           IF (bHaveTransform NE 0) THEN BEGIN           ; Trackball updates.
               sState.oModel->GetProperty, TRANSFORM=t
               sState.oModel->SetProperty, TRANSFORM=t#qmat
               BBoxFade, sState.oBBox, sState.oModel
               sState.oMainWindow->Draw, sState.oMainView
           END
        END
        'SLIDER': BEGIN
               sState.zoomf = sEvent.value/10.
               print,'zoomf:',sState.zoomf
               WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState    ; set state
               i = WIDGET_INFO(sEvent.top, FIND_BY_UNAME='ZOOMF')
               if i gt 0 then WIDGET_CONTROL, i, $
                 set_value=str(sState.zoomf,format='(f5.1)')
               i = WIDGET_INFO(sEvent.top, FIND_BY_UNAME='ZOOM')
               if i gt 0 then WIDGET_CONTROL, i, $
                 set_value=str(sState.zoom,format='(f5.3)')
        END
        'ZOOM': BEGIN
               sState.zoom = (sState.zoomf*sState.zoom) < 1.0
               viz_click, sState, {x:0, y:-1, top:sEvent.top}
               WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
         END
        'ZOOM-RESET': BEGIN
               sState.zoom = 1.
               sState.center = sState.sz0[1:3]/2
               viz_click, sState, {x:0, y:-1, top:sEvent.top}
               WIDGET_CONTROL, sEvent.top, SET_UVALUE=sState
         END
        'SETHOME': BEGIN
               sState.oModel->GetProperty, TRANSFORM=t
               save, t, file='home.idlsave'
        END
        'GETHOME': BEGIN
               restore, file='home.idlsave'
               sState.oModel->SetProperty, TRANSFORM=t
               sState.oMainWindow->Draw, sState.oMainView
        END
        'PNG': BEGIN
               oImage = sState.oMainWindow->read()
               oImage->GetProperty, data=im
               write_png, 'idl.png', color_quan(im,1,r,g,b), r,g,b
        END
        'JPEG': BEGIN
               oImage = sState.oMainWindow->read()
               oImage->GetProperty, data=im
               write_jpeg, 'idl.jpg', im, /true
        END
        'VRML': BEGIN
               oVRML = obj_new('IDLgrVRML')
               oVRML->draw, sState.oMainView
               obj_destroy, oVRML
        END
        ELSE: BEGIN
           print, 'VOLVIZ_EVENT: Unexpected UVALUE = ',uval
        END
     ENDCASE
END
;
; Copyright (c) 1997-1999, Research Systems, Inc.  All rights reserved.
;	Unauthorized reproduction prohibited.
;+
; NAME:
;	AATRACKBALL
;
; PURPOSE:
;	This object translates widget events for draw widgets into
;       transformations that emulate a virtual trackball (for transforming
;       object graphics in three dimensions).
;
; CATEGORY:
;	Object Graphics.
;
; CALLING SEQUENCE:
;	To initially create:
;		oTrackball = OBJ_NEW('aaTrackball', Center, Radius)
;
;	To update the trackball state based on a widget event:
;		oTrackball->Update, sEvent
;
;	To re-initialize the trackball state:
;		oTrackball->Reset, Center, Radius
;
;	To destroy:
;		OBJ_DESTROY, oTrackball
;
; INPUTS:
;   TRACKBALL::INIT:
;	Center:	A two-dimensional vector, [x,y], representing the requested
;		center (measured in device units) of the trackball.
;       Radius:	The requested radius (measured in device units) of the
; 		trackball.
;
;   TRACKBALL::UPDATE:
;        sEvent: The widget event structure.  The event type indicates
;		how the trackball state should be updated.
;
;   TRACKBALL::RESET:
;	Center:	A two-dimensional vector, [x,y], representing the requested
;		center (measured in device units) of the trackball.
;       Radius:	The requested radius (measured in device units) of the
; 		trackball.
;
; KEYWORD PARAMETERS:
;   TRACKBALL::INIT:
;	AXIS:		Set this keyword to indicate the axis about which
;			rotations are to be constrained if the CONSTRAIN
;			keyword is set to a nonzer value.  Valid values
;			include:
;				0 = X-Axis
;				1 = Y-Axis
;				2 = Z-Axis (default)
;	CONSTRAIN:	Set this keyword to a nonzero value to indicate that
;			the trackball transformations are to be constrained
;			about a given axis (as specified by the AXIS
;			keyword).  The default is zero (no constraints).
;	MOUSE		Silently ignored, for compatibilty with IDL's Trackball
;
;   TRACKBALL::UPDATE:
;	MOUSE:	Silently ignored, for compatibilty with IDL's Trackball
;
;	TRANSFORM:	Set this keyword to a named variable that upon
;			return will contain a floating point 4x4 array
;			if a transformations matrix is calculated as
;			a result of the widget event.
;	TRANSLATE:	Set this keyword to indicate that the trackball
;			movement should be constrained to x and y translation
;			rather than rotation about an axis.
;
;   TRACKBALL::RESET:
;	AXIS:		Set this keyword to indicate the axis about which
;			rotations are to be constrained if the CONSTRAIN
;			keyword is set to a nonzer value.  Valid values
;			include:
;				0 = X-Axis
;				1 = Y-Axis
;				2 = Z-Axis (default)
;	CONSTRAIN:	Set this keyword to a nonzero value to indicate that
;			the trackball transformations are to be constrained
;			about a given axis (as specified by the AXIS
;			keyword).  The default is zero (no constraints).
;	MOUSE:	Silently ignored, for compatibilty with IDL's Trackball
;
; OUTPUTS:
;   TRACKBALL::UPDATE:
;	This function returns a 1 if a transformation matrix is calculated
;	as a result of the widget event, or 0 otherwise.
;
; EXAMPLE:
;	Create a trackball centered on a 512x512 pixel drawable area, and
;	a view containing the model to be manipulated:
;		xdim = 512
;		ydim = 512
;		wBase = WIDGET_BASE()
;		wDraw = WIDGET_DRAW(wBase, XSIZE=xdim, YSIZE=ydim, $
;		                    GRAPHICS_LEVEL=2, /BUTTON_EVENTS, $
;		                    /MOTION_EVENTS, /EXPOSE_EVENTS, RETAIN=0 )
;		WIDGET_CONTROL, wBase, /REALIZE
;		WIDGET_CONTROL, wDraw, GET_VALUE=oWindow
;
;		oTrackball = OBJ_NEW('Trackball', [xdim/2.,ydim/2.], xdim/2.)
;		oView = OBJ_NEW('IDLgrView')
;		oModel = OBJ_NEW('IDLgrModel')
;		oView->Add, oModel
;
;		XMANAGER, 'TrackEx', wBase
;
;	In the widget event handler, handle trackball updates.
;	As the trackball transformation changes, update the transformation
;	for a model object (instance of IDLgrModel), and redraw the view:
;
;	PRO TrackEx_Event, sEvent
;		...
;		bHaveXform = oTrackball->Update( sEvent, TRANSFORM=TrackXform )
;		IF (bHaveXform) THEN BEGIN
;		    oModel->GetProperty, TRANSFORM=ModelXform
;		    oModel->SetProperty, TRANSFORM=ModelXform # TrackXform
;		    oWindow->Draw, oView
;		ENDIF
;		...
;	END
;
; MODIFICATION HISTORY:
; 	Written by:	DD, December 1996
;
;-

;----------------------------------------------------------------------------
; TRACKBALL_CONSTRAIN
;
; Purpose:
;  Given a point and a constraint vector, map the point to its constrained
;  equivalent.
;
; Arguments:
;  pt - The unconstrained point.
;  vec - A three-element vector, [x,y,z], representing the unit vector about
;        which rotations are constrained.
;
FUNCTION TRACKBALL_CONSTRAIN, pt, vec
    ; Project the point.
    proj = pt - TOTAL(vec * pt) * vec

    ; Normalizing factor.
    norm = SQRT(TOTAL(proj^2))

    IF (norm GT 0.0) THEN BEGIN
        IF (proj[2] LT 0.0) THEN $
            cpt = -1.0 / norm * proj $
        ELSE $
            cpt = 1.0 / norm * proj
    ENDIF ELSE IF vec[2] EQ 1.0 THEN $
        cpt = [1.0, 0.0, 0.0] $
    ELSE $
        cpt = [-vec[1], vec[0], 0.0] / SQRT(TOTAL(vec[0:1]^2))

    RETURN, cpt
END

;----------------------------------------------------------------------------
; TRACKBALL::UPDATE
;
; Purpose:
;  Given a widget event structure, updates the trackball state.
;
;  The return value is nonzero if a transformation matrix is calculated
;  as a result of the event, or zero otherwise.
;
; Arguments:
;  sEvent - The widget event structure.
;
; Keywords:
;  TRANSFORM - If a transformation matrix is calculated, upon return
;              transform will contain a 4x4 matrix.
;
FUNCTION aaTRACKBALL::UPDATE, sEvent, TRANSFORM=transform, $
     MOUSE=mouse, TRANSLATE=translate
  ; Initialize return value.
  bHaveTransform=0

  IF (N_ELEMENTS(mouse) NE 0) THEN BEGIN
      if (mouse ne 1) and (mouse ne 2) and (mouse ne 4) then begin
          PRINT, 'Trackball: invalid value for MOUSE keyword.'
          RETURN, 0
      ENDIF ELSE $
          self.mouse = mouse
  ENDIF ; Don't set self.mouse if no argument, keep setting from INIT

  ; Ignore non-Draw-Widget events.
  IF (TAG_NAMES(sEvent, /STRUCTURE_NAME) NE 'WIDGET_DRAW') THEN $
    RETURN, bHaveTransform
  ; Determine event type.

  CASE sEvent.type OF
    0: BEGIN    ;Button press.
         ; Only handle event if appropriate mouse button.
         ;aa IF (sEvent.press EQ self.mouse) THEN BEGIN
           self.mouse = sEvent.press

           ; Calculate distance of mouse click from center of unit circle.
           xy = ([sEvent.x,sEvent.y] - self.center) / self.radius
           r = TOTAL(xy^2)
           IF (r GT 1.0) THEN $
             self.pt1 = [xy/SQRT(r) ,0.0] $
           ELSE $
             self.pt1 = [xy,SQRT(1.0-r)]

           ; Constrain if necessary.
           IF (self.constrain NE 0) THEN BEGIN
               vec = [0.,0.,0.]
               vec[self.axis] = 1.0
               self.pt1 = TRACKBALL_CONSTRAIN( self.pt1, vec)
           ENDIF
           self.pt0 = self.pt1
           self.btndown = 1b
         ;aa ENDIF
       END

    2: BEGIN    ;Button motion.
         IF (self.btndown EQ 1b) THEN BEGIN
           ;aa print, sEvent.type, sEvent.press, sEvent.release, sEvent.x
           ; Calculate distance of mouse click from center of unit circle.
           xy = ([sEvent.x,sEvent.y] - self.center) / $
                self.radius
           r = TOTAL(xy^2)
           IF (r GT 1.0) THEN $
             pt1 = [xy/SQRT(r) ,0.0] $
           ELSE $
             pt1 = [xy,SQRT(1.0-r)]

           ; Constrain if necessary.
           IF (self.constrain NE 0) THEN BEGIN
               vec = [0.,0.,0.]
               vec[self.axis] = 1.0
               pt1 = TRACKBALL_CONSTRAIN( pt1, vec)
           ENDIF

           ; Update the transform only if the mouse button has actually
           ; moved from its previous location.
           pt0 = self.pt0
           IF ((pt0[0] NE pt1[0]) OR $
               (pt0[1] NE pt1[1]) OR $
               (pt0[2] NE pt1[2])) THEN BEGIN
             ; Compute transformation.
             q = [CROSSP(pt0,pt1), TOTAL(pt0*pt1)]

             x = q[0]
             y = q[1]
             z = q[2]
             w = q[3]

             bHaveTransform = 1b
             CASE self.mouse OF
             1: begin		; left button
                transform = [[ w^2+x^2-y^2-z^2, 2*(x*y-w*z), 2*(x*z+w*y), 0], $
                             [ 2*(x*y+w*z), w^2-x^2+y^2-z^2, 2*(y*z-w*x), 0], $
                             [ 2*(x*z-w*y), 2*(y*z+w*x), w^2-x^2-y^2+z^2, 0], $
                             [ 0          , 0          , 0              , 1]]
                end
             2: begin		; middle button
               ; translation only
                transform = [[ 1, 0, 0, pt1[0]-pt0[0] ], $
                             [ 0, 1, 0, pt1[1]-pt0[1] ], $
                             [ 0, 0, 1,             0 ], $
                             [ 0, 0, 0,             1 ]  ]
                end
             4: begin		; right button
                s = exp(-(pt1[1]-pt0[1]))
                transform = [[ s, 0, 0,             0 ], $
                             [ 0, s, 0,             0 ], $
                             [ 0, 0, s,             0 ], $
                             [ 0, 0, 0,             1 ]  ]
                end
             5: begin		; both buttons
               ; translation only
                transform = [[ 1, 0, 0, pt1[0]-pt0[0] ], $
                             [ 0, 1, 0, pt1[1]-pt0[1] ], $
                             [ 0, 0, 1,             0 ], $
                             [ 0, 0, 0,             1 ]  ]
                end
             else: begin
                  bHaveTransform = 0b
                end
             endcase
             self.pt0 = pt1
           ENDIF

           self.pt1 = pt1
         ENDIF
       END

    1: BEGIN    ;Button Release.
         IF (self.btndown EQ 1b) THEN $
           self.btndown = 0b
       END

    ELSE: RETURN, bHaveTransform

   ENDCASE

  RETURN, bHaveTransform
END

;----------------------------------------------------------------------------
; aaTRACKBALL::INIT
;
; Purpose:
;   Initializes the trackball state.
;
; Arguments:
;  center - A two-dimensional vector, [x,y], representing the requested
;           center (measured in device units) of the trackball.
;  radius - The requested radius (measured in device units) of the trackball.
;
; Keywords:
;  AXIS -  Set this keyword to indicate the axis about which rotations
;          are to be constrained if the CONSTRAIN keyword is set to a
;          nonzero value).  Valid values include:
;               0 = X
;               1 = Y
;               2 = Z (default)
;  CONSTRAIN - Set this keyword to a nonzero value to indicate that the
;          trackball transformations are to be constrained about a given
;          axis (as specified by the AXIS keyword).  The default is zero
;          (no constraints).
;  MOUSE - Set this keyword to a bitmask to indicate which mouse button to
;          honor for trackball events.  The least significant bit represents
;          the leftmost button, the next highest bit represents the middle
;          button, and the next highest bit represents the right button.
;          The default is 1b, for the left moust button.
;
FUNCTION aaTRACKBALL::INIT, center, radius, AXIS=axis, CONSTRAIN=constrain, $
                          MOUSE=mouse
    IF (N_ELEMENTS(center) NE 2) THEN BEGIN
        PRINT, 'Trackball: center must be a two-dimensional array.'
        RETURN, 0
    ENDIF

    IF (N_ELEMENTS(radius) NE 1) THEN BEGIN
        PRINT, 'Trackball: invalid radius.'
        RETURN, 0
    ENDIF

    IF (N_ELEMENTS(axis) NE 0) THEN BEGIN
        IF (axis lt 0) OR (axis gt 2) THEN BEGIN
            PRINT, 'Trackball: invalid value for AXIS keyword.'
            RETURN, 0
        ENDIF ELSE $
            self.axis = axis
    ENDIF ELSE $
        self.axis = 2

    IF (N_ELEMENTS(constrain) NE 0) THEN $
        self.constrain = constrain $
    ELSE $
        self.constrain = 0

    IF (N_ELEMENTS(mouse) NE 0) THEN BEGIN
        if (mouse ne 1) and (mouse ne 2) and (mouse ne 4) then begin
            PRINT, 'Trackball: invalid value for MOUSE keyword.'
            RETURN, 0
        ENDIF ELSE $
            self.mouse = mouse
    ENDIF ELSE $
        self.mouse = 1 ; Default is left mouse button

    self.center = center
    self.radius = radius
    self.btndown = 0b

    RETURN, 1
END

;----------------------------------------------------------------------------
; aaTRACKBALL::CLEANUP
;
; Purpose:
;   Cleanup the trackball when it is destroyed.
;
; Arguments:
;  <None>
;
; Keywords:
;  <None>
;
PRO aaTRACKBALL::CLEANUP
    ; No work needs to be done.  We provide this method to avoid any
    ; problems resolving the Cleanup method call on Windows 3.11
    ; which has short filename restrictions.
END

;----------------------------------------------------------------------------
; aaTRACKBALL::RESET
;
; Purpose:
;   Resets the trackball state.
;
; Arguments:
;  center - A two-dimensional vector, [x,y], representing the requested
;           center (measured in device units) of the trackball.
;  radius - The requested radius (measured in device units) of the trackball.
;
; Keywords:
;  MOUSE - Set this keyword to a bitmask to indicate which mouse button to
;          honor for trackball events.  The least significant bit represents
;          the leftmost button, the next highest bit represents the middle
;          button, and the next highest bit represents the right button.
;          The default is 1b, for the left moust button.
;
PRO aaTRACKBALL::RESET, center, radius, AXIS=axis, CONSTRAIN=constrain, $
                      MOUSE=mouse
    IF (N_ELEMENTS(center) NE 2) THEN BEGIN
        PRINT, 'aaTrackball: center must be a two-dimensional array.'
        RETURN
    ENDIF

    IF (N_ELEMENTS(radius) NE 1) THEN BEGIN
        PRINT, 'aaTrackball: invalid radius.'
        RETURN
    ENDIF

    IF (N_ELEMENTS(axis) NE 0) THEN BEGIN
        IF (axis lt 0) OR (axis gt 2) THEN BEGIN
            PRINT, 'aaTrackball: invalid value for AXIS keyword.'
            RETURN
        ENDIF ELSE $
            self.axis = axis
    ENDIF ELSE $
        self.axis = 2

    IF (N_ELEMENTS(constrain) NE 0) THEN $
        self.constrain = constrain $
    ELSE $
        self.constrain = 0

    IF (N_ELEMENTS(mouse) NE 0) THEN BEGIN
        if (mouse ne 1) and (mouse ne 2) and (mouse ne 4) then begin
            PRINT, 'aaTrackball: invalid value for MOUSE keyword.'
            RETURN
        ENDIF ELSE $
            self.mouse = mouse
    ENDIF ELSE $
        self.mouse = 1 ; Default is left mouse button

    self.center = center
    self.radius = radius

    self.btndown = 0b

END

;----------------------------------------------------------------------------
; aaTRACKBALL__DEFINE
;
; Purpose:
;  Defines the object structure for a trackball object.
;
PRO aatrackball__define

  struct = {aatrackball, $
            btndown: 0b,    $
            axis: 0, $
            constrain: 0b, $
            mouse: 0b, $
            center: LONARR(2), $
            radius: 0.0, $
            pt0: FLTARR(3), $
            pt1: FLTARR(3) $
           }
END

PRO default, var, val, set=set
   COMMON cdefault, res
   if n_elements(set) ne 0 then res=set
   if n_elements(val) eq 0 then return
   if n_elements(res) eq 0 then res=0
   if n_elements(var) eq 0 or res ne 0 then var=val
END

; ------------------------------------------------------------------------------
FUNCTION str,x,_extra=e
  return,strtrim(string(x,_extra=e),2)
END

;----------------------------------------------------------------
PRO viz_cleanup, sState
  ndata = sState.ndata
  pdata = *(sState.pdata)
  for i=0,ndata-1 do begin
    ptr_free, pdata[i]
  end
END

;----------------------------------------------------------------
PRO viz_zoom, data, zoom, center
    sz = size(data)
    mid = [sz[1]/2,sz[2]/2,sz[3]/2]
    data = shift(data,mid[0]-center[0],mid[1]-center[1],mid[2]-center[2])
    ix1 = long(mid[0]*(1.-zoom)) & ix2=long(mid[0]*(1.+zoom)) < (sz[1]-1)
    iy1 = long(mid[1]*(1.-zoom)) & iy2=long(mid[1]*(1.+zoom)) < (sz[2]-1)
    iz1 = long(mid[2]*(1.-zoom)) & iz2=long(mid[2]*(1.+zoom)) < (sz[3]-1)
    data = data(ix1:ix2,iy1:iy2,iz1:iz2)
END

;----------------------------------------------------------------
PRO viz_click, sState, sEvent
  ndata = sState.ndata

  colors = *(sState.colors)
  indices = *(sState.indices)
  opacities = *(sState.opacities)

  which = sEvent.x*ndata/sState.xszPlot
  which = (which > 0) < (n_elements(opacities)-1)

  if sEvent.y lt 0 then begin
    which=0
  end else if sEvent.y lt 8 then begin
    opacities[which] = float((sEvent.x*ndata) > 0.)/sState.xszPlot mod 1.
  end else begin
    indices[which] = long(255.*((sEvent.y+1.) > 0)/sState.yszPlot) < 255
    colors[which] = 255 - (long(255.*((sEvent.x*ndata) > 0.)/sState.xszPlot) mod 256)
  end
  color = colors[which]
  index = indices[which]
  opacity = opacities[which]

  *(sState.colors) = colors
  *(sState.indices) = indices
  *(sState.opacities) = opacities

  pdata = *(sState.pdata)

  levels = fltarr(ndata)
  for i=0,ndata-1 do begin
    data = *(pdata[i])
    viz_zoom, data, sState.zoom, sState.center
    sState.sz = size(data)
    min = min(data,max=max)
    index = indices[i]
    color = colors[i]
    index = 1 > index < 254
    level = min + index/255.*(max-min)
    levels[i] = level
    if i eq which then level1=level
    shade_volume, data, level, ivert, ipoly
    nvert = (size(ivert))[2]
    icolors = replicate(color,nvert)
    opacity = opacities[i]
    itexture_coord = replicate(0.25+0.5*opacity, 2, nvert)
    ihist = alog10(histogram(data, min=min, max=max, binsize=(max-min)/255.)+1.)
    ihist = [float(i), i+1-ihist/max(ihist), float(i+1)]/ndata
    iscale = indgen(n_elements(ihist))
    iliney = [index,index]
    ilinex = [float(i), float(i+1)]/ndata
    if i eq 0 then begin
      vert = ivert
      poly = ipoly
      vcolors = icolors
      nvert = (size(vert))[2]
      texture_coord = itexture_coord
      scale = iscale
      hist = ihist
      liney = iliney
      linex = ilinex
    end else begin
      vert  = transpose([transpose(ivert),transpose(vert)])
      texture_coord = transpose([transpose(itexture_coord),transpose(texture_coord)])
      k=0
      while (k lt n_elements(poly)) do begin
        n=poly(k)
        for j=1,n do poly(k+j)=poly(k+j)+nvert
        k=k+n+1
      end
      poly  = [ipoly,poly]
      vcolors = [icolors,vcolors]
      scale = [scale,iscale]
      hist = [hist,ihist]
      liney = [liney,iliney]
      linex = [linex,ilinex]
    end
  end
  *(sState.levels) = levels
  *(sState.pdata) = pdata
  if n_elements(vert) eq 0 then return

  nvert = (size(vert))[2]             ; number of vertices
;  texture_coord = replicate(opacity, 2, nvert)      ; texture coordinates
;  help,opacity

  sState.oPolygon->GetProperty, TEXTURE_MAP=texture_map
  texture_map->GetProperty, DATA=texture
  texture(0,*,3) = 0
  texture(1,*,3) = 255
  texture_map->SetProperty, DATA=texture

  xcc = sState.xcc
  ycc = sState.ycc
  zcc = sState.zcc
  xcc[1] = xcc[1]/sState.zoom
  ycc[1] = ycc[1]/sState.zoom
  zcc[1] = zcc[1]/sState.zoom

  sState.oPolygon->SetProperty, $
    DATA=vert, POLYGONS=poly, VERT_COLOR=vcolors, $
    XCOORD_CONV=xcc, YCOORD_CONV=ycc, ZCOORD_CONV=zcc, $
    TEXTURE_MAP=texture_map, TEXTURE_COORD=texture_coord, $
    TEXTURE_INTERP=1, /SHADING

  sState.oLine->SetProperty, DATAX=linex, DATAY=liney
  sState.oPlot->SetProperty, DATAX=hist, DATAY=scale
  xsz = sState.xszPlot
  ysz = sState.yszPlot
  image = bytscl(rebin(reform((xsz-findgen(xsz)-1)*ndata mod xsz,xsz,1),xsz,ysz))
  i2 = xsz/ndata
  for i=0,ndata-1 do begin
    i0 = i*i2
    i1 = i0+i2-1
    image[i0:i1,0:7] = colors[i]
  end
  sState.oPlotImage->SetProperty, DATA=image
  sState.oPlotWindow->draw, sState.oPlotView
  sState.oMainWindow->draw, sState.oMainView

  i = WIDGET_INFO(sEvent.top, FIND_BY_UNAME='LEVEL')
  if i gt 0 then WIDGET_CONTROL, i, $
    set_value=str(level1,format='(g10.3)')
  i = WIDGET_INFO(sEvent.top, FIND_BY_UNAME='ZOOM')
  if i gt 0 then WIDGET_CONTROL, i, $
    set_value=str(sState.zoom,format='(f5.3)')
END

PRO isoadd, data, sState, opacity=opacity, index=index, color=color, $
            level=level, plevel=plevel
  wBase = sState.wBase
  widget_control, wBase, bad=bad, get_uvalue=sState
  if bad ne 0 then return

  opdata  = *(sState.pdata)
  indices = *(sState.indices)
  colors = *(sState.colors)
  opacities = *(sState.opacities)
  levels = *(sState.levels)
  ndata = sState.ndata
  ndata = ndata+1
  pdata = ptrarr(ndata)
  pdata[0:ndata-2] = opdata
  pdata[ndata-1] = ptr_new(data)
  sState.pdata = ptr_new(pdata)
  sState.ndata = ndata
  min=min(data,max=max)
  default, plevel, 0.9
  default, level, plevel*max+(1.-plevel)*min
  default, index, fix(255.*(level-min)/(max-min))
  default, opacity, 1.
  default, color, 200
  indices = [indices,index]
  colors = [colors,color]
  opacities = [opacities,opacity]
  levels = [levels,level]
  sState.indices = ptr_new(indices)
  sState.colors = ptr_new(colors)
  sState.opacities = ptr_new(opacities)
  sState.levels = ptr_new(levels)
  print,ndata,' data sets'

  widget_control, wBase, set_uvalue=sState

  viz_click, sState, {x:0, y:-1, top:wBase}
END

;----------------------------------------------------------------
PRO isoupd, data, state, opacity=opacity, index=index, which=which, $
             color=color, level=level

    default, which, 0

    wBase = state.wBase
    widget_control, wBase, bad=bad, get_uvalue=state
    if bad ne 0 then return

    pdata     = *(state.pdata)
    colors    = *(state.colors)
    indices   = *(state.indices)
    opacities = *(state.opacities)

    *(pdata[which])=data
    if n_elements(level  ) gt 0 then begin
      min=min(data,max=max)
      index = 255.*(level-min)/(max-min)
    end
    if n_elements(color  ) gt 0 then colors   [which] = color
    if n_elements(index  ) gt 0 then indices  [which] = index
    if n_elements(opacity) gt 0 then opacities[which] = opacity

    *(state.colors) = colors
    *(state.indices) = indices
    *(state.opacities)= opacities

    viz_click, state, {x:0, y:-1, top:wBase}
END

;----------------------------------------------------------------
PRO isoviz, object, state, xsize=xsz, ysize=ysz, ctable=coltab, $
       dx=dx, dy=dy, dz=dz, state=sState, plevel=plevel, level=level, $
       pVector=pVector, opacity=opacity, index=index, color=color, $
       transform=transform
  COMMON colors, r,g,b,ro,go,bo

  if n_elements(state) ne 0 then begin
    if widget_info(state.wBase,/active) gt 0 then begin
      isoadd2, object, state
      return
    endif
  endif

  IF N_PARAMS() EQ 0 THEN BEGIN
    print, "ISOVIZ, object, xsize=xsz, ysize=ysz, colortable=coltab, dx=dx, dy=dy, dz=dz"
    print, "    object: a 3D data array, or a structure {data:d, dx:dx, dy:dy, dz:dz}"
    print, "     xsize: window x-size"
    print, "     ysize: window y-size"
    print, "colortable: color table number (default=40), or an RGB triplet"
    print, " "
    print, "  left mousebutton: rotate"
    print, "middle mousebutton: translate"
    print, " right mousebutton: dolly"
    return
  ENDIF

  default, xsz, 835
  default, ysz, 710
  default, color, 200
  default, plevel, 0.9

  default, coltab, 39

  s=size(object)
  IF s(s(0)+1) EQ 8 THEN BEGIN
    data=object.data
    if tag_exists(object, 'vector') then pVector = object.vector
    dx=object.dx & dy=object.dy & dz=object.dz
  END ELSE BEGIN
    data=object
  END
  default, dx, 1.
  default, dy, 1.
  default, dz, 1.

  s = size(data)
  sz0 = s
  mx = s(1)  & my = s(2)    & mz = s(3)
  sx = dx*mx & sy = dy*my   & sz = dz*mz
  size = sqrt(sx^2+sy^2+sz^2)

  xcc = [-sx/2.,dx]/size
  ycc = [-sy/2.,dy]/size
  zcc = [-sz/2.,dz]/size

  dev = !d.name
  set_plot,'z'
  IF n_elements(coltab) eq 1 THEN BEGIN
    loadct, coltab, ncol=256
  END ELSE IF n_elements(coltab) eq 3 THEN BEGIN
    r = replicate(coltab[0], 256)
    g = replicate(coltab[1], 256)
    b = replicate(coltab[2], 256)
  END ELSE BEGIN
    loadct, 0, ncol=256
    print, 'COLORTABLE should be either a colortable number or an RGB triple'
  END
  set_plot, dev
  rgb = reform([r,g,b],256,3)
  oPalette = obj_new('IDLgrPalette', RED=r, GREEN=g, BLUE=b)

  min = min(data,max=max)
  if min eq max then begin              ; create fake variation
    eps = 1e-6*abs(max)+1e-20
    data(mx/2,my/2,mz/2) = data(mx/2,my/2,mz/2)+eps
    max = max+eps
  endif
  default, level , (1.-plevel)*min + plevel*max
  default, index, byte(255.*(level-min)/(max-min))
  ;help, min, max, index, level
  shade_volume, data, level, vert, poly

  nvert = (size(vert))[2]                                                       ; number of vertices
  default, opacity, 0.5                                                         ; transparency
  texture_coord = replicate(0.25+0.5*opacity, 2, nvert)                         ; texture coordinates
  texture = bytarr(2,2,4)
  texture(*,*,0:2) = 255                                                        ; texture color: white
  texture(0,*,3) = 0                                                            ; left opacity = 0
  texture(1,*,3) = 255                                                          ; right opacity = 255
  texture_map = obj_new('IDLgrImage',texture,INTERLEAVE=2)                      ; image object
  vert_colors = replicate(color, nvert)

  oPolygon = obj_new('IDLgrPolygon', vert, POLYGONS=poly, $
    VERT_COLOR=vert_colors, PALETTE=oPalette, /SHADING, $
    XCOORD_CONV=xcc, YCOORD_CONV=ycc, ZCOORD_CONV=zcc, $
    TEXTURE_map=texture_map, TEXTURE_COORD=texture_coord, TEXTURE_INTERP=1)

  XBox = mx*[0,1,0,1,0,1,0,1]
  YBox = my*[0,0,1,1,0,0,1,1]
  ZBox = mz*[0,0,0,0,1,1,1,1]
  BBox = [5,0,1,3,2,0, 5,4,5,7,6,4, 2,0,4, 2,1,5, 2,2,6, 2,3,7, -1]
  oBBox = obj_new('IDLgrPolyLine', XBox, YBox, ZBox, POLYLINES=BBox, $
    COLOR=[255,255,255], XCOORD_CONV=xcc, YCOORD_CONV=ycc, ZCOORD_CONV=zcc)

  oMainView  = obj_new('IDLgrView', projection=2, color=[50,50,50])  ;, depth=[-2,2])

  zoomf = 0.9
  zoom = 1.0

  wBase = WIDGET_BASE(/ROW, XPAD=0, YPAD=0, TITLE="IsoViz2", $
    /TLB_KILL_REQUEST_EVENTS,/TLB_SIZE_EVENTS)
  wButtons = WIDGET_BASE(wBase, /COL, UVALUE='BUTTONS',/BASE_ALIGN_CENTER)
  wLAB  = WIDGET_LABEL (wButtons, VALUE='Snap:')
  wPng  = WIDGET_BUTTON(wButtons, VALUE='PNG', UVALUE='PNG')
  wJPEG = WIDGET_BUTTON(wButtons, VALUE='JPEG', UVALUE='JPEG')
  wVRML = WIDGET_BUTTON(wButtons, VALUE='VRML', UVALUE='VRML')
  wLAB  = WIDGET_LABEL (wButtons, VALUE='Zoom:')
  wLAB  = WIDGET_LABEL (wButtons, UVALUE='ZOOMF', UNAME='ZOOM', $
    VALUE=str(zoom,format='(f5.3)'))
  wLAB  = WIDGET_LABEL (wButtons, UVALUE='ZOOMF', UNAME='ZOOMF', $
    VALUE=str(zoomf,format='(f4.1)'))
  wLAB  = WIDGET_SLIDER(wButtons, UVALUE='SLIDER', UNAME='SLIDER', $
    min=1, max=20, value=fix(10.*zoomf), /vertical, /suppress_value)
  wLAB  = WIDGET_LABEL (wButtons, VALUE='Level:')
  wLAB  = WIDGET_LABEL (wButtons, UVALUE='LEVEL', UNAME='LEVEL', $
    VALUE=str(level,format='(g10.3)'))
  wOUT = WIDGET_BUTTON(wButtons, VALUE='ZOOM', UVALUE='ZOOM')
  wRES = WIDGET_BUTTON(wButtons, VALUE='RESET', UVALUE='ZOOM-RESET')
  wLAB  = WIDGET_LABEL (wButtons, VALUE='Home:')
  print, 'level:', level
  wVRML = WIDGET_BUTTON(wButtons, VALUE='SET', UVALUE='SETHOME')
  wVRML = WIDGET_BUTTON(wButtons, VALUE='GET', UVALUE='GETHOME')
  wDraw = WIDGET_DRAW(wBase, XSIZE=xsz, YSIZE=ysz, UVALUE='MAIN', $
    RETAIN=0, /EXPOSE_EVENTS, /BUTTON_EVENTS, GRAPHICS_LEVEL=2)
  ;help, xsz, ysz

  WIDGET_CONTROL, wBase, /REALIZE
  WIDGET_CONTROL, wDraw, GET_VALUE=oMainWindow
  WIDGET_CONTROL, wDraw, /DRAW_MOTION

  oModel = obj_new('IDLgrModel')
  oModel->add, oPolygon
  oModel->add, oBBox
  oMainView->add, oModel
  get_bounds, oModel, xr, yr, zr
  oMainView->setproperty, dept=[zr(0),zr(1)+2.5*(zr(1)-zr(0))]
  set_view, oMainView, oMainWindow, /isotr

  oLight0 = obj_new('IDLgrLight', TYPE=0, INTENSITY=0.50)
  oLight1 = obj_new('IDLgrLight', TYPE=1, INTENSITY=0.75, LOCATION=[ 1, 1, 0])
  oLight2 = obj_new('IDLgrLight', TYPE=1, INTENSITY=0.95, LOCATION=[-1, 1, 1])
  oLights = obj_new('IDLgrModel')
  oLights->add, oLight0
  oLights->add, oLight1
  oLights->add, oLight2
  oMainView->add, oLights

  if keyword_set(transform) then begin
    oModel->SetProperty, TRANSFORM=transform
  end else begin
    scl=0.95
    oModel->scale, scl,scl,scl
    oModel->rotate, [1,1,0], 15
  end

  yszPlot=ysz
  xszPlot=128
  wPlot = WIDGET_DRAW(wBase, XSIZE=xszPlot, YSIZE=yszPlot, UVALUE='HIST', $
    RETAIN=0, /EXPOSE_EVENTS, /BUTTON_EVENTS, GRAPHICS_LEVEL=2)
  WIDGET_CONTROL, wPlot, /DRAW_MOTION
  WIDGET_CONTROL, wPlot, GET_VALUE=oPlotWindow

  hist = alog10(histogram(data, min=min, max=max, binsize=(max-min)/255.)+0.1)
  hist = 255.*hist/max(hist)
  yccp = [0.,1./255.] & xccp = [0.,1.]
  oPlot  = obj_new('IDLgrPlot', indgen(n_elements(hist)), DATAX=hist, $
    color=255, XCOORD=xccp, YCOORD=yccp)
  oLine  = obj_new('IDLgrPlot', [index,index], DATAX=[0,max(hist)], $
    color=255, XCOORD=xccp, YCOORD=yccp)
  oPlotModel = obj_new('IDLgrModel')
  image = bytscl(rebin(reform(findgen(xszPlot),xszPlot,1),xszPlot,yszPlot))
  oPlotImage = obj_new('IDLgrImage', image, PALETTE=oPalette, $
    XCOORD=[0.,1./xszPlot], YCOORD=[0.,1./yszPlot])
  oPlotView  = obj_new('IDLgrView', viewplane=[0.,0.,1.,1.], color=[50,50,50])
  oPlotModel->add, oPlotImage
  oPlotModel->add, oPlot
  oPlotModel->add, oLine
  oPlotView->add, oPlotModel
  oPlotWindow->draw, oPlotView

  oTrack = obj_new('aaTrackball', [xsz/2.,ysz/2.], (xsz < ysz)/2.)

  oHolder = obj_new('IDL_Container')
  oHolder->add, oMainView
  oHolder->add, oPlotView
  oHolder->add, oTrack

  ndata = 1
  pdata = ptrarr(ndata)
  pdata[0] = ptr_new(data)
  colors = replicate(color,ndata)
  indices = replicate(index, ndata)
  opacities = replicate(opacity,ndata)
  indices[0] = index
  sz = size(data)
  center = [sz[1],sz[2],sz[3]]/2

  sState = {  oHolder:     oHolder,          $
              oTrack:      oTrack,           $
              oModel:      oModel,           $
              oBBox:       oBBox,            $
              oLights:     oLights,          $
              oMainView:   oMainView,        $
              oMainWindow: oMainWindow,      $
              wBase:       wBase,            $
              wDraw:       wDraw,            $
              wButtons:    wButtons,         $
              oPlot:       oPlot,            $
              oPlotView:   oPlotView,        $
              oPlotImage:  oPlotimage,       $
              oPlotWindow: oPlotWindow,      $
              oPolygon:    oPolygon,         $
              oLine:       oLine,            $
              wPlot:       wPlot,            $
              xsize:       xsz,              $
              ysize:       ysz,              $
              xszPlot:     xszPlot,          $
              yszPlot:     yszPlot,          $
              min:         min,              $
              max:         max,              $
              xcc:         xcc,              $
              ycc:         ycc,              $
              zcc:         zcc,              $
              ndata:       1,                $
              pdata:       ptr_new(pdata),   $
              indices:     ptr_new(indices), $
              opacities:   ptr_new(opacities), $
              colors:      ptr_new(colors),  $
              levels:      ptr_new(levels),  $
              level:       level,            $
;              pVector:     pVector,         $
              type:        'isoviz',         $
              sz:          sz,               $
              sz0:         sz0,              $
              center:      center,           $
              zoom:        zoom,             $
              zoomf:       zoomf,            $
              active:      0                 $
             }
  state = sState
  WIDGET_CONTROL, wBase, SET_UVALUE=sState
  viz_click, sState, {x:0, y:-1, top:wBase}
  XMANAGER, 'viz2', wBase, /NO_BLOCK
END
PRO defset,i
   COMMON cdefault, res
   if n_elements(i) eq 0 then i=1
   res=i
END
