; $Id: read_namelist.pro,v 1.1 2010/06/01 10:52:09 kg Exp $
;+------------------------------------------------------------------------------
 FUNCTION read_namelist,file,namelist=nml,verbose=verbose,unit=unit
; Extract namelist values from a file.
;
; SYNTAX: 
;
; IDL> s=read_namelist('file.nml'[,'namelist_name'])
; IDL> help,s,/structure
;
;-------------------------------------------------------------------------------
  if n_elements(file) eq 0 then begin
    doc_library,'read_namelist'
    return, 0
  end
  if n_elements(unit) eq 1 then u=unit else openr,u,/get,file
  line=''
  cmd=''
  if keyword_set(nml) then begin
    in_namelist=0
    nml=strlowcase(nml)
  end else in_namelist=1

  done=0
  while (not eof(u)) and (not done) do begin
    readf,u,line
    line=strlowcase(line)
    if keyword_set(verbose) then print,'line:',line
    if keyword_set(nml) then begin
      if not in_namelist and strpos(line,'&'+nml) ge 0 then in_namelist=1
    end else begin
      if not in_namelist and strpos(line,'&') ge 0 then in_namelist=1
    end
    if keyword_set(verbose) then print,'in_namelist=',in_namelist
    if in_namelist then begin
      i = strpos(line,'=')
      while (i gt 0) and (i lt strlen(line)) do begin
        if keyword_set(verbose) then print,'= sign at ',i

        i1=i+1
        while (strmid(line,i1,1) eq ' ') and (i1 lt strlen(line)) do i1=i1+1
        i2=i1+1

  	if strmid(line,i1,1) eq "'" or (strmid(line,i1,1) eq '"') then begin
	  cstop=strmid(line,i1,1)
          while (strmid(line,i2,1) ne cstop) and (i2 lt strlen(line)) do i2=i2+1
	  i2=i2+1
	end else begin
	  cstop=' '
	  while (strmid(line,i2,1) ne ' ') and (i2 lt strlen(line)) and (strmid(line,i2,1) ne ',') do i2=i2+1
	end

        if keyword_set(verbose) then print,'val at ',i1,i2
        if cstop eq ' ' then val=strmid(line,i1,i2-i1) else val='"'+strtrim(strmid(line,i1+1,i2-i1-2))+'"'
        if keyword_set(verbose) then print,'val = ',val,':'
        if strlowcase(val) eq "f" then val='0'
        if strlowcase(val) eq "t" then val='1'

        if strpos(val,',') gt 0 then begin
          comma=strpos(val,',')
          l=strlen(val)
          newval='['+strmid(val,0,comma-1)
          while (comma lt l and comma ge 0) do begin
            prev=comma+1
            comma=strpos(val,',',comma+2)
            fld=strmid(val,prev,comma-prev-1)
            if strlowcase(fld) eq "f" then fld='0'
            if strlowcase(fld) eq "t" then fld='1'
            newval=newval+','+fld
          end
          val=newval+']'
        end

        if strpos(val,'*') gt 0 then begin
          star=strpos(val,'*')
          n=long(strmid(val,0,star))
          l=strlen(val)
          fld=strmid(val,star+1,l-star-1)
          if strlowcase(fld) eq "f" then fld='0'
          if strlowcase(fld) eq "t" then fld='1'
          val='['+fld
          for j=0,n-2 do val=val+','+fld
          val=val+']'
          print,val
        end

	i2=i-1
	while (strmid(line,i2,1) eq ' ') and (i2 lt strlen(line)) do i2=i2-1
	i1=i2-1
	while (strmid(line,i1,1) ne ' ') and (i1 ge 0) and (strmid(line,i1,1) ne ',') do i1=i1-1
	i1=i1+1
	i2=i2+1
        if keyword_set(verbose) then print,'var at ',i1,i2
        var=strmid(line,i1,i2-i1)
        if keyword_set(verbose) then print,'var = ',var

; The "case" string is special; append an underscore
	if var eq 'case' then var=var+'_'

; Some compilers print string values without quotation marks--handle those here
        if (stregex(val,'[a-zA-Z/]') ge 0) and $                                ; contains letters or /
	   (stregex(val,'[0-9][eE][+-]') eq -1) and $                           ; does not contain exponent
	   (strpos(val,'"') eq -1) and $                                        ; does not contain "
	   (strpos(val,"'") eq -1) then begin                                   ; does not contain '
	     val='"'+val+'"'
	end 

        if cmd eq '' then new=var+':'+val else new=cmd+','+var+':'+val
        cmd=new
        if keyword_set(verbose) then print,'cmd = ',cmd
        i = strpos(line,'=',i+2)
      end
    end
    if keyword_set(nml) then begin
      ; print,strpos(line,' /'),strpos(line,'/')
      if in_namelist and (strpos(line,' /') ge 0 or strpos(line,'/') eq 0) then begin
        in_namelist=0
        done=1
      end
    end
  end

  if cmd eq '' then cmd='str=-1' else cmd='str={'+cmd+'}'
  if keyword_set(verbose) then print,cmd
  void=execute(cmd)
  if keyword_set(nml) then unit=u else free_lun,u
  return,str
END
