@stagger

PRO stagger2vti, a, j, file, dr, sample, np=np

if (n_params() eq 0) then begin
	print,'stagger2vti, a, j, file, dr, sample, np=np'
        print,'   a:     associated array to data'
	print,'   j:     snapshot number'
	print,'   file:  the main name of the vti output file'
	print,'   dr:    domain size'
        print,'   sample: sample the data grid'
        print,'   np :   keyword set when the domain is not periodic in y,z'
	return
endif

common grid, dx, dy, dz

if n_elements(dr) eq 0 then dr=[1.,1.,1.]

sz=size(a) & mx=sz[1] & my=sz[2] & mz=sz[3]
dx=dr[0]/mx
dy=dr[1]/my
dz=dr[2]/mz

grid=lonarr(6)
grid(1)=mx-1
if keyword_set(np) eq 0 then begin
  grid(3)=my-1
  grid(5)=mz-1
endif else begin
  grid(3)=my-2
  grid(5)=mz-2
endelse
if n_elements(sample) ne 0 then grid=grid/sample

dr=float(dr)/[grid(1),grid(3),grid(5)]

wc0=systime(1)
close,2
openw,2,strcompress(file+'.'+STRTRIM(j,2)+'.vti',/remove)
printf,2,'<?xml version="1.0"?>'
printf,2,'<VTKFile type="ImageData" version="0.1" byte_order="LittleEndian">'
printf,2,'<ImageData WholeExtent="'+STRTRIM(grid(0))+STRTRIM(grid(1))+STRTRIM(grid(2))+$
STRTRIM(grid(3))+STRTRIM(grid(4))+STRTRIM(grid(5))+$
'" Origin="0 0 0 " Spacing="'+STRTRIM(dr(0))+STRTRIM(dr(1))+STRTRIM(dr(2))+'">'
printf,2,'<Piece Extent="'+STRTRIM(grid(0))+STRTRIM(grid(1))+STRTRIM(grid(2))+STRTRIM(grid(3))+STRTRIM(grid(4))+STRTRIM(grid(5))+'">'
;printf,2,'<PointData Scalars="rho,Bx,By,Bz,jx,jy,jz,vx,vy,vz">'
printf,2,'<PointData Scalars="rho" Vectors="B,J,V">'
printf,2,'<DataArray type="Float32" Name="rho" format="ascii">'
if n_elements(sample) gt 0 then begin
  tmp=a(j*8)
;  tmp=rmpi(j,np=np)
  r=fltarr(grid(1)+1,grid(3)+1,grid(5)+1)
  ii=indgen(grid(1)+1)*sample
  for kk=0,grid(5) do begin for jj=0,grid(3) do r(*,jj,kk)=tmp(ii,jj*sample,kk*sample) & end
endif else begin
  r=a(j*8)
;   r=rmpi(j,np=np)
endelse
;print,'r'
wc=systime(1)
printf,2,r
;print,systime(1)-wc,' sec'
printf,2,'</DataArray>'
printf,2,'<DataArray type="Float32" Name="B" format="ascii" NumberOfComponents="3">'
wc=systime(1)
if n_elements(sample) gt 0 then begin
  tmp=bvec(a,j,/per)
  bv=fltarr(grid(1)+1,grid(3)+1,grid(5)+1,3)
  ii=indgen(grid(1)+1)*sample
  for ll=0,2 do begin for kk=0,grid(5) do begin for jj=0,grid(3) do bv(*,jj,kk,ll)=tmp(ii,jj*sample,kk*sample,ll) & end & end
endif else begin
  bv=bvec(a,j,/per)
endelse
;print,systime(1)-wc,' sec read'
;print,'B' & wc=systime(1)
for kk=0,grid(5) DO BEGIN FOR jj=0,grid(3) DO BEGIN
  ; printf,2,format='(15f10.6)',tmp
  printf,2,transpose(reform(bv(*,jj,kk,*)))
END & End
;print,systime(1)-wc,' sec'
printf,2,'</DataArray>'
printf,2,'<DataArray type="Float32" Name="J" format="ascii" NumberOfComponents="3">'
if n_elements(sample) gt 0 then begin
  tmp=ivec(a,j,/per)
  iv=fltarr(grid(1)+1,grid(3)+1,grid(5)+1,3)
  ii=indgen(grid(1)+1)*sample
  for ll=0,2 do begin for kk=0,grid(5) do begin for jj=0,grid(3) do iv(*,jj,kk,ll)=tmp(ii,jj*sample,kk*sample,ll) & end & end
endif else begin
  iv=ivec(a,j,/per)
endelse
;print,'J' & wc=systime(1)
for kk=0,grid(5) DO BEGIN FOR jj=0,grid(3) DO BEGIN
  printf,2,transpose(reform(iv(*,jj,kk,*)))
END & End
;print,systime(1)-wc,' sec'
printf,2,'</DataArray>'
printf,2,'<DataArray type="Float32" Name="V" format="ascii" NumberOfComponents="3">'
if n_elements(sample) gt 0 then begin
  tmp=vvec(a,j,/per)
  vv=fltarr(grid(1)+1,grid(3)+1,grid(5)+1,3)
  ii=indgen(grid(1)+1)*sample
  for ll=0,2 do begin for kk=0,grid(5) do begin for jj=0,grid(3) do vv(*,jj,kk,ll)=tmp(ii,jj*sample,kk*sample,ll) & end & end
endif else begin
  vv=vvec(a,j,/per)
endelse
;print,'V' & wc=systime(1)
for kk=0,grid(5) DO BEGIN FOR jj=0,grid(3) DO BEGIN
  printf,2,transpose(reform(vv(*,jj,kk,*)))
END & End
;print,systime(1)-wc,' sec'
printf,2,'</DataArray>'
printf,2,'</PointData>'
printf,2,'</Piece>'
printf,2,'</ImageData>'
printf,2,'</VTKFile>'
close,2
print,'snapshot',j,systime(1)-wc0,' sec', format='(a,i4,f9.1,a)'

END
