!*******************************************************************************! initial values
SUBROUTINE init_values
  USE grid_m
  USE io_m, only: iread, iwrite
<<<<<<< fourier_field.f90
  USE mhd_m, only: gamma!, pi
=======
  USE mhd_m, only: gamma
>>>>>>> 1.3
  USE stagger_m
  implicit none
  real B0, beta
  real, dimension(3) :: amp, kv
  real fmaxval, fminval, rmax, rmin, emax, emin, bxmax, bxmin, bymax, bymin, bzmax, bzmin
  integer ix, iy, iz, ii
  namelist /init/ B0, beta 
  namelist /init_model/ amp, kv
!...............................................................................
  B0=1.; beta =0.1
  amp(1)=1.; amp(2)=.13; amp(3)=.0169
  kv(1)=1.; kv(2)=4.; kv(3)=16.
  rewind(txt_input); read (txt_input,init); if (master) write(*,init)
  rewind(txt_input); read (txt_input,init_model); if (master) write(*,init_model)

  if (iread==0) then                                                    ! iread==0 for new initial cond.
    rho = 1.
    px  = 0.
    py  = 0.
    pz  = 0.
    e   = (beta/(gamma-1.))*rho                                         ! ideal gas

    bx = 0.
    by = 0.
    bz = 0.

    do ix=1, mx
      do iy=1, my
        do iz=1, mz
          do ii=1, 3
<<<<<<< fourier_field.f90
             bx(ix, iy, iz) = bx(ix, iy, iz) + &
              kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*y(iy))-sin(kv(ii)*pi*2.*y(iy))+cos(kv(ii)*pi*2.*z(iz))-sin(kv(ii)*pi*2.*z(iz)))*B0 
             by(ix, iy, iz) = by(ix, iy, iz) + &
              kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*z(iz))-sin(kv(ii)*pi*2.*z(iz))+cos(kv(ii)*pi*2.*x(ix))-sin(kv(ii)*pi*2.*x(ix)))*B0 
             bz(ix, iy, iz) = bz(ix, iy, iz) + &
              kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*x(ix))-sin(kv(ii)*pi*2.*x(ix))+cos(kv(ii)*pi*2.*y(iy))-sin(kv(ii)*pi*2.*y(iy)))*B0 
=======
             bx(ix, iy, iz) = bx(ix, iy, iz) + kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*y(iy))&
             -sin(kv(ii)*pi*2.*y(iy))+cos(kv(ii)*pi*2.*z(iz))-sin(kv(ii)*pi*2.*z(iz)))*B0 
             by(ix, iy, iz) = by(ix, iy, iz) + kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*z(iz))&
             -sin(kv(ii)*pi*2.*z(iz))+cos(kv(ii)*pi*2.*x(ix))-sin(kv(ii)*pi*2.*x(ix)))*B0 
             bz(ix, iy, iz) = bz(ix, iy, iz) + kv(ii)*amp(ii)*(-cos(kv(ii)*pi*2.*x(ix))&
             -sin(kv(ii)*pi*2.*x(ix))+cos(kv(ii)*pi*2.*y(iy))-sin(kv(ii)*pi*2.*y(iy)))*B0 
>>>>>>> 1.3
!             bx(ix, iy, iz) = bx(ix, iy, iz) + amp(ii)*(cos(kv(ii)*pi*2.*y(iy))-sin(kv(ii)*pi*2.*z(iz)))*B0 
!             by(ix, iy, iz) = by(ix, iy, iz) + amp(ii)*(cos(kv(ii)*pi*2.*z(iz))-sin(kv(ii)*pi*2.*x(ix)))*B0 
!             bz(ix, iy, iz) = bz(ix, iy, iz) + amp(ii)*(cos(kv(ii)*pi*2.*x(ix))-sin(kv(ii)*pi*2.*y(iy)))*B0 
          enddo
        enddo
      enddo
    enddo
    bx = xdn(bx)
    by = ydn(by)
    bz = zdn(bz)
   
    rmax = fmaxval(rho) ; rmin = fminval(rho)
    emax = fmaxval(e)   ; emin = fminval(e)
    bxmax = fmaxval(bx) ; bxmin = fminval(bx)
    bymax = fmaxval(by) ; bymin = fminval(by)
    bzmax = fmaxval(bz) ; bzmin = fminval(bz)
    if (master) then
      print *,'maxval(rho),minval(rho) :',rmax, rmin
      print *,'maxval(e),minval(e)     :',emax,emin
      print *,'maxval(bx),minval(bx)   :',bxmax,bxmin
      print *,'maxval(by),minval(by)   :',bymax,bymin
      print *,'maxval(bz),minval(bz)   :',bzmax,bzmin
    endif

    iwrite = 1                                                          ! first snapshot = initial state
    call write_snapshot                                                 ! write out initial state (support.f90)
  else
    call read_snapshot                                                  ! read previous snapshot (support.f90)
  end if
END SUBROUTINE

!*******************************************************************************

